diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-test.cc ns-3.39/src/wifi/test/wifi-test.cc
--- ns-3.38/src/wifi/test/wifi-test.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wifi/test/wifi-test.cc	2023-07-05 14:23:48.133428300 -0700
@@ -27,6 +27,7 @@
 #include "ns3/error-model.h"
 #include "ns3/fcfs-wifi-queue-scheduler.h"
 #include "ns3/frame-exchange-manager.h"
+#include "ns3/header-serialization-test.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/interference-helper.h"
 #include "ns3/mgt-headers.h"
@@ -47,6 +48,7 @@
 #include "ns3/wifi-default-ack-manager.h"
 #include "ns3/wifi-default-assoc-manager.h"
 #include "ns3/wifi-default-protection-manager.h"
+#include "ns3/wifi-mgt-header.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-ppdu.h"
 #include "ns3/wifi-psdu.h"
@@ -55,6 +57,8 @@
 #include "ns3/yans-wifi-helper.h"
 #include "ns3/yans-wifi-phy.h"
 
+#include <optional>
+
 using namespace ns3;
 
 // Helper function to assign streams to random variables, to control
@@ -1795,7 +1799,7 @@
     {
         MgtBeaconHeader beacon;
         packet->RemoveHeader(beacon);
-        const auto& htOperation = beacon.GetHtOperation();
+        const auto& htOperation = beacon.Get<HtOperation>();
         if (htOperation.has_value() && htOperation->GetStaChannelWidth() > 0)
         {
             m_countOperationalChannelWidth40++;
@@ -3626,6 +3630,157 @@
                           "Data rate verification for RUs above 52-tone RU (included) failed");
 }
 
+/// List of Information Elements included in the test management frame
+using MgtTestElems =
+    std::tuple<SupportedRates, std::optional<ExtendedSupportedRatesIE>, std::vector<Ssid>>;
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test management header
+ */
+class MgtTestHeader : public WifiMgtHeader<MgtTestHeader, MgtTestElems>
+{
+  public:
+    ~MgtTestHeader() override = default;
+
+    /**
+     * Register this type.
+     * \return The TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * \return the TypeId for this object.
+     */
+    TypeId GetInstanceTypeId() const override;
+
+    using WifiMgtHeader<MgtTestHeader, MgtTestElems>::GetSerializedSize;
+    using WifiMgtHeader<MgtTestHeader, MgtTestElems>::Serialize;
+    using WifiMgtHeader<MgtTestHeader, MgtTestElems>::Deserialize;
+};
+
+TypeId
+MgtTestHeader::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::MgtTestHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<MgtTestHeader>();
+    return tid;
+}
+
+TypeId
+MgtTestHeader::GetInstanceTypeId() const
+{
+    return GetTypeId();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Mgt header (de)serialization Test Suite
+ */
+class WifiMgtHeaderTest : public HeaderSerializationTestCase
+{
+  public:
+    WifiMgtHeaderTest();
+    ~WifiMgtHeaderTest() override = default;
+
+  private:
+    void DoRun() override;
+};
+
+WifiMgtHeaderTest::WifiMgtHeaderTest()
+    : HeaderSerializationTestCase("Check (de)serialization of a test management header")
+{
+}
+
+void
+WifiMgtHeaderTest::DoRun()
+{
+    MgtTestHeader frame;
+
+    // Add the mandatory Information Element (SupportedRates)
+    AllSupportedRates allRates;
+    allRates.AddSupportedRate(1000000);
+    allRates.AddSupportedRate(2000000);
+    allRates.AddSupportedRate(3000000);
+    allRates.AddSupportedRate(4000000);
+    allRates.AddSupportedRate(5000000);
+
+    frame.Get<SupportedRates>() = allRates.rates;
+    frame.Get<ExtendedSupportedRatesIE>() = allRates.extendedRates;
+
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<SupportedRates>().has_value(),
+                          true,
+                          "Expected a SupportedRates IE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<ExtendedSupportedRatesIE>().has_value(),
+                          false,
+                          "Expected no ExtendedSupportedRatesIE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<Ssid>().size(), 0, "Expected no Ssid IE to be included");
+
+    TestHeaderSerialization(frame);
+
+    // Add more rates, so that the optional Information Element (ExtendedSupportedRatesIE) is added
+    allRates.AddSupportedRate(6000000);
+    allRates.AddSupportedRate(7000000);
+    allRates.AddSupportedRate(8000000);
+    allRates.AddSupportedRate(9000000);
+    allRates.AddSupportedRate(10000000);
+
+    frame.Get<SupportedRates>() = allRates.rates;
+    frame.Get<ExtendedSupportedRatesIE>() = allRates.extendedRates;
+
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<SupportedRates>().has_value(),
+                          true,
+                          "Expected a SupportedRates IE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<ExtendedSupportedRatesIE>().has_value(),
+                          true,
+                          "Expected an ExtendedSupportedRatesIE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<Ssid>().size(), 0, "Expected no Ssid IE to be included");
+
+    TestHeaderSerialization(frame);
+
+    // Add a first Ssid IE
+    Ssid one("Ssid One");
+    frame.Get<Ssid>().push_back(one);
+
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<SupportedRates>().has_value(),
+                          true,
+                          "Expected a SupportedRates IE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<ExtendedSupportedRatesIE>().has_value(),
+                          true,
+                          "Expected an ExtendedSupportedRatesIE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<Ssid>().size(), 1, "Expected one Ssid IE to be included");
+    NS_TEST_EXPECT_MSG_EQ(std::string(frame.Get<Ssid>().front().PeekString()),
+                          "Ssid One",
+                          "Incorrect SSID");
+
+    TestHeaderSerialization(frame);
+
+    // Add a second Ssid IE
+    frame.Get<Ssid>().emplace_back("Ssid Two");
+
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<SupportedRates>().has_value(),
+                          true,
+                          "Expected a SupportedRates IE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<ExtendedSupportedRatesIE>().has_value(),
+                          true,
+                          "Expected an ExtendedSupportedRatesIE to be included");
+    NS_TEST_EXPECT_MSG_EQ(frame.Get<Ssid>().size(), 2, "Expected two Ssid IEs to be included");
+    NS_TEST_EXPECT_MSG_EQ(std::string(frame.Get<Ssid>().front().PeekString()),
+                          "Ssid One",
+                          "Incorrect first SSID");
+    NS_TEST_EXPECT_MSG_EQ(std::string(frame.Get<Ssid>().back().PeekString()),
+                          "Ssid Two",
+                          "Incorrect second SSID");
+
+    TestHeaderSerialization(frame);
+}
+
 /**
  * \ingroup wifi-test
  * \ingroup tests
@@ -3658,6 +3813,7 @@
     AddTestCase(new IdealRateManagerChannelWidthTest, TestCase::QUICK);
     AddTestCase(new IdealRateManagerMimoTest, TestCase::QUICK);
     AddTestCase(new HeRuMcsDataRateTestCase, TestCase::QUICK);
+    AddTestCase(new WifiMgtHeaderTest, TestCase::QUICK);
 }
 
 static WifiTestSuite g_wifiTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/examples/wimax-ipv4.cc ns-3.39/src/wimax/examples/wimax-ipv4.cc
--- ns-3.38/src/wimax/examples/wimax-ipv4.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/examples/wimax-ipv4.cc	2023-07-05 14:23:48.133428300 -0700
@@ -50,7 +50,6 @@
 //       +-----+    +-----+    +-----+
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/global-route-manager.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/examples/wimax-multicast.cc ns-3.39/src/wimax/examples/wimax-multicast.cc
--- ns-3.38/src/wimax/examples/wimax-multicast.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/examples/wimax-multicast.cc	2023-07-05 14:23:48.133428300 -0700
@@ -50,7 +50,6 @@
 //       +-----+    +-----+    +-----+    +-----+    +-----+
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/global-route-manager.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/examples/wimax-simple.cc ns-3.39/src/wimax/examples/wimax-simple.cc
--- ns-3.38/src/wimax/examples/wimax-simple.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/examples/wimax-simple.cc	2023-07-05 14:23:48.133428300 -0700
@@ -42,7 +42,6 @@
 //       +-----+
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/global-route-manager.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-net-device.cc ns-3.39/src/wimax/model/bs-net-device.cc
--- ns-3.38/src/wimax/model/bs-net-device.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-net-device.cc	2023-07-05 14:23:48.133428300 -0700
@@ -639,7 +639,7 @@
     NS_LOG_INFO("BS (" << source << "):");
     NS_LOG_INFO("\tSending packet...");
     NS_LOG_INFO("\t\tDestination: " << dest);
-    NS_LOG_INFO("\t\tPaket Size:  " << packet->GetSize());
+    NS_LOG_INFO("\t\tPacket Size:  " << packet->GetSize());
     NS_LOG_INFO("\t\tProtocol:    " << protocolNumber);
 
     if (protocolNumber == 2048)
@@ -716,7 +716,7 @@
     packet->RemoveHeader(gnrcMacHdr);
     if (gnrcMacHdr.GetHt() == MacHeaderType::HEADER_TYPE_GENERIC)
     {
-        if (gnrcMacHdr.check_hcs() == false)
+        if (!gnrcMacHdr.check_hcs())
         {
             // The header is noisy
             m_bsRxDropTrace(packet);
@@ -882,7 +882,7 @@
         packet->RemoveHeader(bwRequestHdr);
         NS_ASSERT_MSG(bwRequestHdr.GetHt() == MacHeaderType::HEADER_TYPE_BANDWIDTH,
                       "A bandwidth request should be carried by a bandwidth header type");
-        if (bwRequestHdr.check_hcs() == false)
+        if (!bwRequestHdr.check_hcs())
         {
             // The header is noisy
             NS_LOG_INFO("BS:Header HCS ERROR");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-scheduler-rtps.cc ns-3.39/src/wimax/model/bs-scheduler-rtps.cc
--- ns-3.38/src/wimax/model/bs-scheduler-rtps.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-scheduler-rtps.cc	2023-07-05 14:23:48.133428300 -0700
@@ -111,7 +111,7 @@
     }
     NS_LOG_INFO(", modulation: " << modulationType << ", DIUC: " << (uint32_t)diuc);
 
-    m_downlinkBursts->push_back(std::make_pair(dlMapIe, burst));
+    m_downlinkBursts->emplace_back(dlMapIe, burst);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-scheduler-simple.cc ns-3.39/src/wimax/model/bs-scheduler-simple.cc
--- ns-3.38/src/wimax/model/bs-scheduler-simple.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-scheduler-simple.cc	2023-07-05 14:23:48.133428300 -0700
@@ -109,7 +109,7 @@
     }
     NS_LOG_INFO(", modulation: " << modulationType << ", DIUC: " << (uint32_t)diuc);
 
-    m_downlinkBursts->push_back(std::make_pair(dlMapIe, burst));
+    m_downlinkBursts->emplace_back(dlMapIe, burst);
 }
 
 void
@@ -187,7 +187,7 @@
         else
         {
             burst = Create<PacketBurst>();
-            while (connection->HasPackets() == true)
+            while (connection->HasPackets())
             {
                 uint32_t FirstPacketSize = connection->GetQueue()->GetFirstPacketRequiredByte(
                     MacHeaderType::HEADER_TYPE_GENERIC);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-service-flow-manager.cc ns-3.39/src/wimax/model/bs-service-flow-manager.cc
--- ns-3.38/src/wimax/model/bs-service-flow-manager.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-service-flow-manager.cc	2023-07-05 14:23:48.133428300 -0700
@@ -221,8 +221,7 @@
 }
 
 void
-BsServiceFlowManager::AddMulticastServiceFlow(ServiceFlow sf,
-                                              enum WimaxPhy::ModulationType modulation)
+BsServiceFlowManager::AddMulticastServiceFlow(ServiceFlow sf, WimaxPhy::ModulationType modulation)
 {
     ServiceFlow* serviceFlow = new ServiceFlow();
     serviceFlow->CopyParametersFrom(sf);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-service-flow-manager.h ns-3.39/src/wimax/model/bs-service-flow-manager.h
--- ns-3.38/src/wimax/model/bs-service-flow-manager.h	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-service-flow-manager.h	2023-07-05 14:23:48.133428300 -0700
@@ -108,7 +108,7 @@
      * \param sf the service flow
      * \param modulation the wimax phy modulation type
      */
-    void AddMulticastServiceFlow(ServiceFlow sf, enum WimaxPhy::ModulationType modulation);
+    void AddMulticastServiceFlow(ServiceFlow sf, WimaxPhy::ModulationType modulation);
     /**
      * \brief process a DSA-ACK message
      * \param dsaAck the message to process
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler.h ns-3.39/src/wimax/model/bs-uplink-scheduler.h
--- ns-3.38/src/wimax/model/bs-uplink-scheduler.h	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler.h	2023-07-05 14:23:48.133428300 -0700
@@ -167,7 +167,7 @@
      * \param availableSymbols the available symbols
      */
     virtual void ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                          enum ServiceFlow::SchedulingType schedulingType,
+                                          ServiceFlow::SchedulingType schedulingType,
                                           OfdmUlMapIe& ulMapIe,
                                           const WimaxPhy::ModulationType modulationType,
                                           uint32_t& symbolsToAllocation,
@@ -182,7 +182,7 @@
      * \param availableSymbols the available symbols
      */
     virtual void ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                          enum ServiceFlow::SchedulingType schedulingType,
+                                          ServiceFlow::SchedulingType schedulingType,
                                           OfdmUlMapIe& ulMapIe,
                                           const WimaxPhy::ModulationType modulationType,
                                           uint32_t& symbolsToAllocation,
@@ -198,7 +198,7 @@
      * \returns true if successful
      */
     virtual bool ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                          enum ServiceFlow::SchedulingType schedulingType,
+                                          ServiceFlow::SchedulingType schedulingType,
                                           OfdmUlMapIe& ulMapIe,
                                           const WimaxPhy::ModulationType modulationType,
                                           uint32_t& symbolsToAllocation,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-mbqos.cc ns-3.39/src/wimax/model/bs-uplink-scheduler-mbqos.cc
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2023-07-05 14:23:48.133428300 -0700
@@ -402,7 +402,7 @@
         Ptr<UlJob> job = m_uplinkJobs_high.front();
         OfdmUlMapIe ulMapIe;
         SSRecord* ssRecord = job->GetSsRecord();
-        enum ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
+        ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
 
         Cid cid = ssRecord->GetBasicCid();
         ulMapIe.SetCid(cid);
@@ -447,7 +447,7 @@
         Ptr<UlJob> job = m_uplinkJobs_inter.front();
         OfdmUlMapIe ulMapIe;
         SSRecord* ssRecord = job->GetSsRecord();
-        enum ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
+        ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
 
         Cid cid = ssRecord->GetBasicCid();
         ulMapIe.SetCid(cid);
@@ -481,7 +481,7 @@
         Ptr<UlJob> job = m_uplinkJobs_low.front();
         OfdmUlMapIe ulMapIe;
         SSRecord* ssRecord = job->GetSsRecord();
-        enum ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
+        ServiceFlow::SchedulingType schedulingType = job->GetSchedulingType();
 
         Cid cid = ssRecord->GetBasicCid();
         ulMapIe.SetCid(cid);
@@ -522,7 +522,7 @@
 
 bool
 UplinkSchedulerMBQoS::ServiceBandwidthRequestsBytes(ServiceFlow* serviceFlow,
-                                                    enum ServiceFlow::SchedulingType schedulingType,
+                                                    ServiceFlow::SchedulingType schedulingType,
                                                     OfdmUlMapIe& ulMapIe,
                                                     const WimaxPhy::ModulationType modulationType,
                                                     uint32_t& symbolsToAllocation,
@@ -587,7 +587,7 @@
 
 Ptr<UlJob>
 UplinkSchedulerMBQoS::CreateUlJob(SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedType,
+                                  ServiceFlow::SchedulingType schedType,
                                   ReqType reqType)
 {
     Ptr<UlJob> job = CreateObject<UlJob>();
@@ -680,7 +680,7 @@
 void
 UplinkSchedulerMBQoS::CheckDeadline(uint32_t& availableSymbols)
 {
-    // for each request in the imermediate queue
+    // for each request in the intermediate queue
     if (!m_uplinkJobs_inter.empty())
     {
         std::list<Ptr<UlJob>>::iterator iter = m_uplinkJobs_inter.begin();
@@ -869,7 +869,7 @@
 
 void
 UplinkSchedulerMBQoS::ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                               enum ServiceFlow::SchedulingType schedulingType,
+                                               ServiceFlow::SchedulingType schedulingType,
                                                OfdmUlMapIe& ulMapIe,
                                                const WimaxPhy::ModulationType modulationType,
                                                uint32_t& symbolsToAllocation,
@@ -937,7 +937,7 @@
 
 void
 UplinkSchedulerMBQoS::ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                               enum ServiceFlow::SchedulingType schedulingType,
+                                               ServiceFlow::SchedulingType schedulingType,
                                                OfdmUlMapIe& ulMapIe,
                                                const WimaxPhy::ModulationType modulationType,
                                                uint32_t& symbolsToAllocation,
@@ -963,7 +963,7 @@
 
 bool
 UplinkSchedulerMBQoS::ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                               enum ServiceFlow::SchedulingType schedulingType,
+                                               ServiceFlow::SchedulingType schedulingType,
                                                OfdmUlMapIe& ulMapIe,
                                                const WimaxPhy::ModulationType modulationType,
                                                uint32_t& symbolsToAllocation,
@@ -1079,7 +1079,7 @@
     switch (serviceFlow->GetSchedulingType())
     {
     case ServiceFlow::SF_TYPE_UGS: {
-        if (serviceFlow->GetIsMulticast() == true)
+        if (serviceFlow->GetIsMulticast())
         {
             modulation = serviceFlow->GetModulation();
         }
@@ -1172,7 +1172,7 @@
 
     Time deadline = DetermineDeadline(serviceFlow);
     Time currentTime = Simulator::Now();
-    Time period = deadline; // So that deadline is properly updated..
+    const Time& period = deadline; // So that deadline is properly updated..
 
     NS_LOG_DEBUG("At " << Simulator::Now().As(Time::S)
                        << " at BS uplink scheduler, processing bandwidth request from."
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-mbqos.h ns-3.39/src/wimax/model/bs-uplink-scheduler-mbqos.h
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-mbqos.h	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-mbqos.h	2023-07-05 14:23:48.133428300 -0700
@@ -136,7 +136,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -151,7 +151,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -167,7 +167,7 @@
      * \returns true if successful
      */
     bool ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -277,7 +277,7 @@
      * Create and fill information of a job.
      */
     Ptr<UlJob> CreateUlJob(SSRecord* ssRecord,
-                           enum ServiceFlow::SchedulingType schedType,
+                           ServiceFlow::SchedulingType schedType,
                            ReqType reqType);
 
     /**
@@ -300,7 +300,7 @@
      * \returns true if successful
      */
     bool ServiceBandwidthRequestsBytes(ServiceFlow* serviceFlow,
-                                       enum ServiceFlow::SchedulingType schedulingType,
+                                       ServiceFlow::SchedulingType schedulingType,
                                        OfdmUlMapIe& ulMapIe,
                                        const WimaxPhy::ModulationType modulationType,
                                        uint32_t& symbolsToAllocation,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-rtps.cc ns-3.39/src/wimax/model/bs-uplink-scheduler-rtps.cc
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-rtps.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-rtps.cc	2023-07-05 14:23:48.133428300 -0700
@@ -361,7 +361,7 @@
 
 void
 UplinkSchedulerRtps::ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                              enum ServiceFlow::SchedulingType schedulingType,
+                                              ServiceFlow::SchedulingType schedulingType,
                                               OfdmUlMapIe& ulMapIe,
                                               const WimaxPhy::ModulationType modulationType,
                                               uint32_t& symbolsToAllocation,
@@ -450,7 +450,7 @@
 
 void
 UplinkSchedulerRtps::ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                              enum ServiceFlow::SchedulingType schedulingType,
+                                              ServiceFlow::SchedulingType schedulingType,
                                               OfdmUlMapIe& ulMapIe,
                                               const WimaxPhy::ModulationType modulationType,
                                               uint32_t& symbolsToAllocation,
@@ -476,7 +476,7 @@
 
 bool
 UplinkSchedulerRtps::ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                              enum ServiceFlow::SchedulingType schedulingType,
+                                              ServiceFlow::SchedulingType schedulingType,
                                               OfdmUlMapIe& ulMapIe,
                                               const WimaxPhy::ModulationType modulationType,
                                               uint32_t& symbolsToAllocation,
@@ -632,7 +632,7 @@
         NS_LOG_INFO("\t\tUpdateGrantedBandwidth for " << i << " = " << allocSizeBytes);
         if (record_[i]->GetRequestedBandwidth() < allocSizeBytes)
         {
-            // the flow need new poll to set the newer requredBandwidth
+            // the flow need new poll to set the newer requiredBandwidth
             record_[i]->SetGrantedBandwidth(0);
             record_[i]->SetRequestedBandwidth(0);
         }
@@ -697,7 +697,7 @@
     switch (serviceFlow->GetSchedulingType())
     {
     case ServiceFlow::SF_TYPE_UGS: {
-        if (serviceFlow->GetIsMulticast() == true)
+        if (serviceFlow->GetIsMulticast())
         {
             modulation = serviceFlow->GetModulation();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-rtps.h ns-3.39/src/wimax/model/bs-uplink-scheduler-rtps.h
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-rtps.h	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-rtps.h	2023-07-05 14:23:48.133428300 -0700
@@ -118,7 +118,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -133,7 +133,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -149,7 +149,7 @@
      * \returns true if successful
      */
     bool ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-simple.cc ns-3.39/src/wimax/model/bs-uplink-scheduler-simple.cc
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-simple.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-simple.cc	2023-07-05 14:23:48.133428300 -0700
@@ -340,7 +340,7 @@
 
 void
 UplinkSchedulerSimple::ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                                enum ServiceFlow::SchedulingType schedulingType,
+                                                ServiceFlow::SchedulingType schedulingType,
                                                 OfdmUlMapIe& ulMapIe,
                                                 const WimaxPhy::ModulationType modulationType,
                                                 uint32_t& symbolsToAllocation,
@@ -415,7 +415,7 @@
 
 void
 UplinkSchedulerSimple::ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                                enum ServiceFlow::SchedulingType schedulingType,
+                                                ServiceFlow::SchedulingType schedulingType,
                                                 OfdmUlMapIe& ulMapIe,
                                                 const WimaxPhy::ModulationType modulationType,
                                                 uint32_t& symbolsToAllocation,
@@ -441,7 +441,7 @@
 
 bool
 UplinkSchedulerSimple::ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                                enum ServiceFlow::SchedulingType schedulingType,
+                                                ServiceFlow::SchedulingType schedulingType,
                                                 OfdmUlMapIe& ulMapIe,
                                                 const WimaxPhy::ModulationType modulationType,
                                                 uint32_t& symbolsToAllocation,
@@ -542,7 +542,7 @@
     switch (serviceFlow->GetSchedulingType())
     {
     case ServiceFlow::SF_TYPE_UGS: {
-        if (serviceFlow->GetIsMulticast() == true)
+        if (serviceFlow->GetIsMulticast())
         {
             modulation = serviceFlow->GetModulation();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/bs-uplink-scheduler-simple.h ns-3.39/src/wimax/model/bs-uplink-scheduler-simple.h
--- ns-3.38/src/wimax/model/bs-uplink-scheduler-simple.h	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/bs-uplink-scheduler-simple.h	2023-07-05 14:23:48.133428300 -0700
@@ -91,7 +91,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceUnsolicitedGrants(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -106,7 +106,7 @@
      * \param availableSymbols the available symbols
      */
     void ServiceBandwidthRequests(const SSRecord* ssRecord,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
@@ -122,7 +122,7 @@
      * \returns true if successful
      */
     bool ServiceBandwidthRequests(ServiceFlow* serviceFlow,
-                                  enum ServiceFlow::SchedulingType schedulingType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   OfdmUlMapIe& ulMapIe,
                                   const WimaxPhy::ModulationType modulationType,
                                   uint32_t& symbolsToAllocation,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wimax/model/cid-factory.cc ns-3.39/src/wimax/model/cid-factory.cc
--- ns-3.38/src/wimax/model/cid-factory.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wimax/model/cid-factory.cc	2023-07-05 14:23:48.133428300 -0700
@@ -71,7 +71,7 @@
 }
 
 Cid
-CidFactory::Allocate(enum Cid::Type type)
+CidFactory::Allocate(Cid::Type type)
 {
     switch (type)
     {
